#!/bin/bash

# Basic4Android installer

#External sources
ScriptPath=$(readlink -f $(dirname ${BASH_SOURCE[0]}))
source $ScriptPath"/"lib_Installer.sh

#Workspace folder Basic4Android (you can change it)
wksB4A=$HOME/workspace_b4a

PackAndroidSdk=android-sdk_r22.6.2-linux.tgz
UrlPackAndroidSdk=http://dl.google.com/android/$PackAndroidSdk
UrlPackAdaptAndroidSdk=http://goo.gl/Vs3QdA

ProgInstallB4A=b4a-trial.exe
UrlB4A=http://www.basic4ppc.com/android/files/$ProgInstallB4A

ProgInstallJdk=jdk-7u55-windows-i586.exe
UrlJdkWindows=http://download.oracle.com/otn-pub/java/jdk/7u55-b13/$ProgInstallJdk

#Variables declaration (do not change it)
WineB4A=$wksB4A/wine_b4a
TmpDir=$wksB4A/temp
init_winedir $WineB4A

echo "============================================"
echo "=  BASIC4ANDROID INSTALLATION FOR UBUNTU.  ="
echo "=        by Zolive33 (Oliver MARÉ)         ="
echo "=                                          ="
echo "=           Version 2014-05-06             ="
echo "=                                          ="
echo "============================================"

echo "************* Before starting **************"
echo "*************** BE CAREFUL *****************"
echo "This script allows you to install Wine 1.6"
echo "But it is better to install it before!"
echo
read -p "Do you want to Continue? (y/n) " yn
if [ "$yn" = "n" ]; then
	exit
fi
echo "**************** Let's GO ******************"

# creating workspace folder for Basic4Android
if ! [ -d "$wksB4A" ]; then
	mkdir $wksB4A
fi

# creating temporary folder
if [ -d "$TmpDir" ]; then
	rm -r $TmpDir
fi
mkdir $TmpDir

# Java installation
$ScriptPath"/"Java_Installer.sh

# Android SDK Installation
if ! [ -d "$wksB4A/android-sdk-linux/" ]; then
	read -p "Do you want to install Android SDK? (y/n) " yn
	if [ "$yn" = "y" ]; then
		wget -P $TmpDir $UrlPackAndroidSdk;
		tar -zxvf $TmpDir/$PackAndroidSdk -C $wksB4A
		$wksB4A/android-sdk-linux/tools/android 2>/dev/null
	fi
else
	echo "----------------------------------------"
	echo "- Android SDK already installed        -"
	echo "----------------------------------------"

fi

#Adaptation for Android SKD (for Wine compatibility)
if [ -d "$wksB4A/android-sdk-linux/tools/" ] && (! [ -f "$wksB4A/android-sdk-linux/platform-tools/adb.exe" ]); then
	echo "echo OFF" > $wksB4A/android-sdk-linux/tools/android.bat
	echo "start /unix $wksB4A/android-sdk-linux/tools/android avd" >> $wksB4A/android-sdk-linux/tools/android.bat
	wget -P $TmpDir -O $TmpDir/sdk-B4A.tar $UrlPackAdaptAndroidSdk;
	tar -xvf $TmpDir/sdk-B4A.tar -C $wksB4A/android-sdk-linux
else
	echo "----------------------------------------"
	echo "- Wine compatibility elements          -"
	echo "- for Android SDK already installed    -"
	echo "----------------------------------------"
fi

# Wine Installation
if ! bin_exists wine; then
	echo "Wine does not seem to be installed on your system."
	read -p "Do you want to install it? (y/n) " yn
	if [ "$yn" = "y" ]; then
		sudo add-apt-repository ppa:ubuntu-wine/ppa
		sudo apt-get update
		sudo apt-get install wine1.6
	fi
else
	echo "----------------------------------------"
	echo "- Wine is already installed            -"
	echo "----------------------------------------"

fi

# Environment preparation for Wine (32 bits)
if ! [ -d "$WineB4A" ]; then
	echo "Initializing Wine's environment"
	WINEARCH=win32 WINEPREFIX=$WineB4A wine do_not_exists 2>/dev/null
	WINEARCH=win32 WINEPREFIX=$WineB4A winetricks dotnet20
else
	echo "----------------------------------------"
	echo "- Environment for Wine 32 bits         -"
	echo "- width dotnet 20 is already installed -"
	echo "----------------------------------------"

fi

# JDK installation (for Windows 32bits)
if ! [ -d "$WineB4A/drive_c/Program Files/Java/" ]; then
	read -p "Do you want to install JDK for windows? (y/n) " yn
	if [ "$yn" = "y" ]; then
		wget --no-cookies --no-check-certificate --header "Cookie: oraclelicense=accept-securebackup-cookie" -P $TmpDir $UrlJdkWindows
		WINEARCH=win32 WINEPREFIX=$WineB4A wine $TmpDir/$ProgInstallJdk
	fi
else
	echo "----------------------------------------"
	echo "- JDK for Windows is already installed -"
	echo "----------------------------------------"
fi

# Basic4Android installation
if [ -f "$WineB4A/drive_c/Program Files/Anywhere Software/Basic4android/Basic4android.exe" ]; then
	echo "----------------------------------------"
	echo "- Basic4android is already installed   -"
	echo "----------------------------------------"
	read -p "Do you want to update Basic4android? (y/n) " yn

else
	yn="y"
fi
if [ "$yn" == "y" ]; then 
	wget -P $TmpDir $UrlB4A
	WINEARCH=win32 WINEPREFIX=$WineB4A wine $TmpDir/$ProgInstallB4A 2>/dev/null
	override_app_dlls Basic4android.exe gdiplus native
fi

#link creation (.desktop)
if ! [ -f "$wksB4A/Basic4android.desktop" ]; then
	echo "[Desktop Entry]" >$wksB4A/Basic4android.desktop
	echo "Name=Basic4android" >>$wksB4A/Basic4android.desktop
	echo "Exec=env WINEPREFIX="\"$WineB4A\"" wine C:\\\\\\\\windows\\\\\\\\command\\\\\\\\start.exe /Unix $WineB4A/dosdevices/c:/users/Public/Start\\\\ Menu/Programs/Basic4android/Basic4android.lnk" >>$wksB4A/Basic4android.desktop
	echo "Type=Application" >>$wksB4A/Basic4android.desktop
	echo "StartupNotify=true" >>$wksB4A/Basic4android.desktop
	echo "Path=$WineB4A/dosdevices/c:/Program Files/Anywhere Software/Basic4android" >>$wksB4A/Basic4android.desktop
	echo "Icon=B5FB_Basic4android.0" >>$wksB4A/Basic4android.desktop
	chmod +x $wksB4A/Basic4android.desktop
else
	echo "----------------------------------------"
	echo "- link for Basic4Android already exists-"
	echo "----------------------------------------"

fi

#remove temproary folder
rm -r $TmpDir
